#ifndef __MD2
#define __MD2

#include <nds.h>
/********************
The header in the MD2 file
*********************/
typedef struct MDL2HEADER
{
	int ident;
	int version;
	int skinwidth;
	int skinheight;
	int framesize;	// byte size of each frame
	int num_skins;
	int num_xyz;
	int num_st;		//greater than num_xyz for seams
	int num_tris;
	int num_glcmds;	//dwords in strip/fan command list
	int num_frames;
	int ofs_skins;	//each skin is a MAX_SKINNAME string
	int ofs_st;		//byte offset from start for stverts
	int ofs_tris;	//offset for dtriangles
	int ofs_frames;	//offset for first frame
	int ofs_glcmds;
	int ofs_end;	//end of file
} mdl2_header_t;

typedef struct MDL2VERTEX
{
	unsigned char v[3]; // scaled byte to fit in frame mins/maxs
	unsigned char lightnormalindex;
} trivertx_t;

typedef struct MDL2FRAME
{
	float scale[3]; // multiply byte verts by this
	float translate[3]; // then add this
	char name[16]; // frame name from grabbing
	trivertx_t verts[1]; // variable sized
} frame_t;

typedef struct MD2MODEL
{
	int open;
	char skinfilename[256];
	int skinopen;
	
	int numglcmds;
	long *glcmds;

	int framesize;
	int numframes;
	char *frames;
} md2_t;

typedef struct vert_t
{
	unsigned char x,y,z;
	float u,v;
} vert_t;

typedef struct vert_nds
{
	short x,y,z;
	float u,v;
	u32 n;
} vert_nds;


int loadMD2Frame(const u8 * md2file, int frame);
int getNumFrames (const u8 * md2file);
#endif
